#define GPIO_ADDRESS    0x80100400
#define GPIO_DATA_IN_OFFSET   0x00
#define GPIO_DATA_OUT_OFFSET  0x04
#define GPIO_DIRECTION_OFFSET 0x08
#define GPIO_IRQ_MASK_OFFSET  0x0C

#define DSU_PC          0x90400010

  .text
  .global start
  
start:
  
  ! Read current PC (program counter)
  set DSU_PC, %o1
  ld [%o1], %o1
  srl %o1, 28, %o1
  or %o1, 0xF00, %o1                    ! 0x00000F00 | PC[31:28]
  
  ! GPIO output
  set GPIO_ADDRESS, %o0
  st %g0, [%o0 + GPIO_IRQ_MASK_OFFSET]  ! All pins ignore external events
  st %o1, [%o0 + GPIO_DATA_OUT_OFFSET]  ! Set data bits
  orn %g0, %g0, %o1
  st %o1, [%o0 + GPIO_DIRECTION_OFFSET] ! All pins to output
  
  ! Endless loop
1:
  ba 1b
   nop
  
  ta 0



